/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2010 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: core_support.S 2075 2011-05-09 03:47:09Z ertl-honda $
 */

/*
 *        RAˑW[ AZuꕔiARMpj
 */

#define TOPPERS_MACRO_ONLY
#define TOPPERS_ASM_MACRO
#define UINT_C(val)		(val)		/* uint_t^̒萔}N */
#define ULONG_C(val)	(val)		/* ulong_t^̒萔}N */
#include "kernel_impl.h"
#include "offset.h"

/*
 * OxN^
 */
    .section .vector,"a"
    .global vector_table
vector_table:
    ldr pc, reset_vector       /* Zbg             */
    ldr pc, undef_vector       /* `           */
    ldr pc, swi_vector         /* \tgEFA   */
    ldr pc, prefech_vector     /* vtFb`A{[g */
    ldr pc, data_abort_vector  /* f[^A{[g       */
    ldr pc, reset_vector
    ldr pc, irq_vector         /* IRQ                  */
    ldr pc, fiq_vector         /* FIQ                  */


/*
 *  OxN^̖߂QƂ
 *  WvAhX
 */
    .global vector_ref_tbl
vector_ref_tbl:
reset_vector:
    .long   start
undef_vector:
    .long   undef_handler
swi_vector:
    .long   swi_handler
prefech_vector:
    .long   prefetch_handler
data_abort_vector:
    .long   data_abort_handler
irq_vector:
    .long   irq_handler
fiq_vector:
    .long   fiq_handler

/*
 *  ^XNfBXpb`
 *
 */
    .text
    .align 2
    .globl dispatch
dispatch:
    /*
     *  ̃[`́C^XNReLXgECPUbNԁEfBXpb`
     *  ԁEif́jݗDx}XNSԂŌĂяo
     *  D
     */
    stmfd sp!, {r4 - r11,lr}           /* WX^̕ۑ */
    ldr   r0, =p_runtsk                /* p_runtskǂݍ */
    ldr   r1, [r0]
    str   sp, [r1,#TCB_sp]             /* ^XNX^bNۑ */
    adr   r2, dispatch_r
    str   r2, [r1,#TCB_pc]             /* sĊJԒnۑ */
    b     dispatcher

dispatch_r:
    ldmfd sp!,{r4 - r11,lr}     /* WX^̕A */
    /*
     * ^XNO[`̋N
     * dispatcherĂяo邽߁CTCB̃AhXr1ɓĂ
     */
    ldrb  r0,[r1,#TCB_enatex]
    tst   r0,#TCB_enatex_mask
    beq   dispatch_r_1          /* enatex  false Ȃ烊^[ */
    ldr   r0,[r1,#TCB_texptn]   /* texptn 0Ȃ烊^[ */
    tst   r0,r0                 
    beq   dispatch_r_1          
    ldr   r1, =ipmflg           /* ipmflgfalseł΃^[ */
    ldr   r0, [r1]
    tst   r0,r0
    bne   call_texrtn           /* ^XNO[`̌Ăяo */
dispatch_r_1:
    bx    lr


/*
 *  fBXpb`̓Jnicpu_support.Sj
 */
    .globl start_dispatch
start_dispatch:
    /*
     *  ̃[`́CJ[lNɁCׂĂ݂̊֎~
     * i݃bNԂƓjŌĂяoD܂C݃[hi
     *  ^XNReLXgƓjŌĂяo邱Ƃz肵ĂD
     *
     *  dispatcheŕCCPUbNԁCif́jݗDx}XNS
     *  ԁCOi/CPUOj̃lXg0ŌĂяoD     
     *  target_initializeł́Cif́jݗDx}XNS
     *  ƂCJ[lǗO݂̊łFIQ邱ƂŁC
     *  CPUbNԁEif́jݗDx}XNSԂɂȂD
     *  ܂Cinitialize_taskdisdspfalseɏĂ邽߁CfB
     *  Xpb`ԂɂȂĂD
     *  
     */    
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) /* CPUbNԂ */
    ldr   r2, =excpt_nest_count            /* Oi/CPUOj̃lXg */
    mov   r0, #0                           /* 0                              */
    str   r0, [r2]
    b     dispatcher_0

/*
 *  ݂̃ReLXĝĂăfBXpb`
 */
    .globl exit_and_dispatch
exit_and_dispatch:
    /* fBXpb`{́idispatcherj */    

/*
 *  fBXpb`{
 */
dispatcher:
    /*
     *  ̃[`́C^XNReLXgECPUbNԁEfBXpb`
     *  ԁEif́jݗDx}XNSԂŌĂяo
     *  DsĊJԒnւ̏Ԃ̂܂ܕ򂷂D
     *
     *  Ȃ킿CX[p[oCU[[hCIRQ֎~EdisdspfalseEdspflg
     *  trueƂȂĂDsĊJԒnւ̏Ԃ̂܂ܕ򂷂D
     */
#ifdef LOG_DSP_ENTER
    ldr   r1, =p_runtsk     /* p_runtskp[^ */
    ldr   r0, [r1]        
    bl    log_dsp_enter
#endif /* LOG_DSP_ENTER */
dispatcher_0:
    ldr   r0, =p_schedtsk   /* p_schedtskp_runtsk */
    ldr   r1, [r0]
    ldr   r2, =p_runtsk   
    str   r1, [r2]        
    cmp   r1, #0            /* p_runtskNULLȂdispatcher_1 */
    beq   dispatcher_1             
    ldr   sp, [r1,#TCB_sp]  /* ^XNX^bN𕜋A */
#ifdef LOG_DSP_LEAVE
    mov   r0, r1            /* p_runtskp[^ */
    mov   r4, r1            /* r1̓XNb`WX^Ȃ̂ŕۑ */
    bl    log_dsp_leave
    mov   r1, r4
#endif /* LOG_DSP_LEAVE */
    ldr   r4, [r1,#TCB_pc]  /* sĊJԒn𕜋A   */    
    bx    r4
dispatcher_1:
    /*
     * CPUbNԂ̉ƁC^XNReLXgsԂւ
     * 
     */
    ldr   r0, =_kernel_istk            /* ^XNReLXg̃X^bN */
    ldr   sp, [r0]    
    ldr   r1, =_kernel_istksz
    ldr   r3, [r1]
    add   sp, sp, r3
    ldr   r2, =reqflg                  /* r2 <- reqflg */
    ldr   r3, =excpt_nest_count        /* r3 <-excpt_nest_count */
    mov   r0, #0
    mov   r1, #1
dispatcher_2:
    /*
     *  ݂C^XNReLXgsԂƂ݂҂D
     *
     *  Ŕ^XNReLXgsԂɐ؂芷̂́CŔ
     *  銄ݏɂǂ̃X^bNgƂ̉ƁC
     *  nhł̃^XNfBXpb`̖h~Ƃ2̈ӖD
     *
     *  vZbTݑ҂Ɉڍs鏈ƁC݋Ƃ́Cs
     *  ɍsȂKvD
     *  sɍsȂȂꍇC݂Ɋ
     *  ݂C̒Ń^XNs\ԂɂȂƁCsׂ^X
     *  Nɂ炸vZbTݑ҂ɂȂĂ܂D
     *
     *  ݑ҂̊Ԃ́Cp_runtskNULLi0jɐݒ肵Ȃ΂Ȃ
     *  D̂悤ɐݒ肵ȂƁC݃nhiget_tidĂяo
     *  ۂ̓삪dlɍvȂȂD
     *
     *  ^[QbgɂẮCȓd̓[hɈڍs邽߁CW̕@
     *  قȂ菇KvȏꍇD
     *  ̂悤ȃ^[Qbgł́C^[QbgˑɂāCTOPPERS_CUSTOM_IDLE
     *  `CAZu}NƂāCtoppers_asm_custom_idle p
     *  ΂悢Dtoppers_asm_custom_idle ̋LqɂẮC̃W
     *  X^͎gpłȂD
     *     r0, r1, r2, r3, sp 
     *
     */
    str   r1, [r3]                          /* excpt_nest_count = 1 */

#ifdef TOPPERS_CUSTOM_IDLE
    toppers_asm_custom_idle
#else
    msr   cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET) /* 荞݋(X[p[oCU[[h) */
    nop
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) /* CPUbN(X[p[oCU[[h) */
#endif /* TOPPERS_CUSTOM_IDLE */

    ldr   r6, [r2]        /* reqflgfalseȂdispatcher_2 */
    cmp   r6, #0          
    beq   dispatcher_2                 
    str   r0, [r2]        /* reqflgfalse */
    str   r0, [r3]        /* excpt_nest_count = 0 */
    b     dispatcher_0


/*
 *  J[l̏Ǐďo
 *
 *  [hƃX^bN^XNReLXgpɐ؂ւD
 */
    .globl call_exit_kernel
call_exit_kernel:
    msr  cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET|CPSR_IRQ_BIT|CPSR_FIQ_BIT) 
    ldr  r0, =_kernel_istkpt       /* ^XNReLXg̃X^bN */
    ldr  sp, [r0]
    b     exit_kernel


/*
 *  ^XNJn
 *
 *  dispatcherĂяo邽߁CTCB̃AhXr1ɓĂ
 */
    .text
    .globl start_r
start_r:
    msr   cpsr, #(CPSR_SVC|CPSR_ALWAYS_SET) /* CPUbNԂ */
    ldr   lr, =ext_tsk                      /* ߂Ԓnݒ */
    ldr   r2, [r1, #TCB_p_tinib]            /* p_runtsk->p_tinibr2  */
    ldr   r0, [r2, #TINIB_exinf]            /* exinfWX^r0  */
    ldr   r1, [r2, #TINIB_task]             /* ^XNNԒnɃWv */
    bx    r1 


/*
 *  ݃nh/CPUOnho
 *
 *  ret_int́C݃nh߂Ɏs郋[`ŁC
 *  ݃nhIC^[Qbgˑ̏sC
 *  J[lǗ݂̊֎~CX^bNݑÕX^bNɂ
 *  ԂŌĂяoD
 */
    .text
    .global ret_int
    .global ret_exc
ret_int:
ret_exc:
    /*
     *  OẼ݂lXgJEgiexcpt_nest_count)̃fNg
     */        
    ldr   r0, =excpt_nest_count   /* r0 <-excpt_nest_count */
    ldr   r1, [r0]
    sub   r2, r1, #1
    str   r2, [r0]
    cmp   r2, #0                  /* ߂悪^XNReLXgȂ */
    bne   ret_int_1               /* Ƀ^[                   */

    /*
     *  reqflg`FbNOɊ݂֎~̂́Creqflg`FbN
     *  Ɋ݃nhNC̒ŃfBXpb`v
     *  ꂽꍇɁCɃfBXpb`ȂƂ肪邽
     *  łD
     */
    ldr   r0, =reqflg
    ldr   r1, [r0]
    cmp   r1, #0                  /* reqflgtruełret_int_2 */
    bne   ret_int_2
ret_int_1:
    /*
     *  ݏ̃^[ɂCCPUbNԂɈڍsȂ
     *  ȂȂD    
     *  ARMł́CCPSRIRQrbgCPUbNԂƂ邽߁CPɃ^[
     *  ΂悢D
     */                
    ldmfd sp!,{r1}              /* CPSR̕A */
    msr   spsr, r1              /* ߂cpsrspsrɐݒ */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ReLXg̕AC^tȂ̂ŁAcpsr <- spsr */

    
ret_int_2:
ret_int_3:
    /*
     *  ւ́CCPUOnh̏o򂵂ĂD
     *
     *  ł́C߂悪^XNłCX^bŃC^XNX^bN̏
     *  ɃXNb`WX^݂̂ۑꂽԂɂȂĂD܂C
     *  vZbT́CX[p[oCU[[hEJ[lǗ݂̊֎~
     *  ԂƂȂĂD
     */    
    ldr   r0, =reqflg    /* reqflgfalse */
    mov   r1, #0
    str   r1, [r0]

    /*
     *  CPUbNԂɈڍsCݗDx}XNݏO̒l
     *  ݒ肷D
     *
     *  ̎_CPUbNԂƂ̂́Cdispatcher֕򂷂鎞ƁC
     *  call_texrtnĂяoɁCCPUbNԂɂȂĂKv
     *  ߂łD
     *
     *  CPUbNԂɊւẮCARMł́CCPSRIRQrbgCPUbN
     *  Ԃ\邽߁Cł́CɉsȂD
     *
     *  ݗDx}XNɊւẮC^[Qbgɑ삪قȂ邽߁C
     *  ݃nhIɃ^[QbgˑŊݏO̒l
     *  ݒ肷D
     */
    
    /*
     *  dspflgfalsełꍇƁCp_runtskp_schedtskꍇɂ́C
     *  fBXpb`sȂD̃`FbNKvȂ̂́C^XNO
     *  [`̌ďoKvȏꍇɁCfBXpb`KvȂĂC
     *  reqflgtrueɂ邽߂łD
     */
    ldr   r0, =p_runtsk       /* p_runtsk r1ɓǂݍ */
    ldr   r1, [r0]
    ldr   r0, =dspflg
    ldr   r2, [r0]
    cmp   r2, #0              /* dspflgfalseȂret_int_4 */
    beq   ret_int_4
    ldr   r0, =p_schedtsk     /* p_schedtsk r2ɓǂݍ */
    ldr   r2, [r0]
    cmp   r1, r2              /* p_runtskp_schedtskȂ */
    beq   ret_int_4           /*                    ret_int_4 */
    stmfd sp!, {r4-r11}       /* c̃WX^ۑ */
    str   sp, [r1,#TCB_sp]    /* ^XNX^bNۑ */
    adr   r0, ret_int_r       /* sĊJԒnۑ   */
    str   r0, [r1,#TCB_pc]
    b     dispatcher

ret_int_r: 
    ldmfd sp!, {r4-r11}       /* WX^̕A */    
ret_int_4:
    /*
     *  enatextrueŁCtexptn0łȂCipmflgtrueł΁C^XN
     *  O[`ĂяoD
     *  dispatcherĂяo邽߁CTCB̃AhXr1ɓĂ
     */
    ldrb  r0, [r1,#TCB_enatex]
    tst   r0, #TCB_enatex_mask
    beq   ret_int_5              /* enatex  false Ȃ ret_int5 */
    ldr   r0, [r1,#TCB_texptn]   /* texptn[h                  */
    tst   r0, r0                 /* texptn 0Ȃ ret_int5       */
    beq   ret_int_5
    ldr   r1, =ipmflg           /* ipmflgfalseł ret_int5 */
    ldr   r0, [r1]
    tst   r0,r0
    blne  call_texrtn            /* ^XNO[`̌Ăяo    */
ret_int_5:
    /*
     *  ݏ̃^[ɂCCPUbNԂɈڍs
     *  ɂDARMCPSRIRQrbgɂCPUbNԂ\Ă
     *  邽߁Ĉ܂܃^[΂悢D
     */        
    ldmfd sp!, {r0}             /* spsr 𕜋A */
    msr   spsr,r0               /* ߂cpsrspsrɐݒ */
    ldmfd sp!,{r0-r3,ip,lr,pc}^ /* ^XNɕA ^tȂ̂ŁAcpsr <- spsr */    
    

/*
 * CPUOnh
 *
 * CPUOnh́C^XNReLXgŎsD
 * 
 */

/*
 *  ` Onh
 */
    .text
    .align 2
    .global undef_handler
undef_handler:
    /* 
     *  ^XN̓쎞[h(X[p[oCU[[h)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pc̓_~[ */

    /*
     * spsrƖ߂Ԓn擾邽߂ɖ`[h
     */
    msr   cpsr, #(CPSR_UND|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_UNDEF
    b     target_exc_handler


/*
 *  SWI Onh
 */
    .text
    .align 2
    .global swi_handler
swi_handler:
    /* 
     *  ^XN̓쎞[h(X[p[oCU[[h)
     *  XX[p[oCU[[hCCPUbNԂƂ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pc̓_~[ */
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_SWI
    b     target_exc_handler


/*
 *  vtFb`A{[h Onh
 */
    .text
    .align 2
    .global prefetch_handler
prefetch_handler:
    /* 
     *  ^XN̓쎞[h(X[p[oCU[[h)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pc̓_~[ */

    /*
     * spsrƖ߂Ԓn擾邽߂ɃA{[g[h
     */
    msr   cpsr, #(CPSR_ABT|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_PABORT
    b     target_exc_handler


/*
 *  f[^A{[h Onh
 */
    .text
    .align 2
    .global data_abort_handler
data_abort_handler:
    /* 
     *  ^XN̓쎞[h(X[p[oCU[[h)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pc̓_~[ */

    /*
     * spsrƖ߂Ԓn擾邽߂ɃA{[g[h
     */
    msr   cpsr, #(CPSR_ABT|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_DABORT
    b     target_exc_handler


#ifndef TARGET_FIQ_HANDLER
/*
 *  FIQ Onh
 */
    .text
    .align 2
    .global fiq_handler
fiq_handler:
    /* 
     *  ^XN̓쎞[h(X[p[oCU[[h)
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_CPULOCK|CPSR_ALWAYS_SET) 
    stmfd sp!, {r0-r3,ip,lr,pc} /* pc̓_~[ */

    /*
     * spsrƖ߂Ԓn擾邽߂FIQ[h
     */
    msr   cpsr, #(CPSR_FIQ|CPSR_FIQ_BIT|CPSR_CPULOCK|CPSR_ALWAYS_SET)
    mov   r0, lr
    mrs   r1, spsr    
    mov   r2, #EXCH_NO_FIQ
    b     target_exc_handler
#endif /* TARGET_FIQ_HANDLER */

/*
 *  ԑ҂
 */
    .globl _sil_dly_nse
_sil_dly_nse:
    sub   r0, r0, #SIL_DLY_TIM1
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr
_sil_dly_nse1:
    sub   r0, r0, #SIL_DLY_TIM2
    cmp   r0, #0
    bgt   _sil_dly_nse1
    bxle  lr

#ifdef __thumb__
    .text
    .align 2
    .global current_sr
current_sr:
    mrs   r0, cpsr
    bx    lr

   .global set_sr
set_sr:
    msr   cpsr, r0
    bx    lr
#endif /* __thumb__ */
