/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2007-2008 by TAKAGI Nobuhisa
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 */
/*!
 *  \file   toppers/itronx/init_helper.hpp
 *  \brief  J[l܂̓W[̏wp[֐̐錾E`
 */
#ifndef TOPPERS_ITRONX_INIT_HELPER_HPP_
#define TOPPERS_ITRONX_INIT_HELPER_HPP_

#include <string>
#include <map>
#include <iostream>
#include "toppers/global.hpp"
#include "toppers/itronx/static_api.hpp"
#include "toppers/itronx/asp/factory.hpp"

namespace toppers
{
  namespace itronx
  {

    /*!
     *  \brief      J[l܂̓W[̏wp[֐
     *  \param[in]  module_name   W[
     *  \param[in]  info_table    ÓIAPIɊւe[u
     *  \param[in]  table_count   info_table ̗vf
     *  retval      true          
     *  retval      false         s
     */
    template < class Factory >
      bool init_helper( std::string const& module_name, static_api::info const* info_table, std::size_t table_count )
    {
      try
      {
        std::map< std::string, static_api::info > temp_map;
        for ( std::size_t i = 0; ( i < table_count ) && ( info_table[ i ].type != 0 ); ++i )
        {
          temp_map[ info_table[ i ].api_name ] = info_table[ i ];
        }
        static std::map< std::string, static_api::info > const info_map( temp_map );
        global( module_name + "_static_api_info_map" ) = static_cast< void const* >( &info_map );	// GCCoO΍

        static Factory factory;
        global( module_name + "_factory" ) = static_cast< itronx::factory* >( &factory );
      }
      catch ( ... )
      {
        std::cerr << "module `" << module_name << "\' is failed to initialize" << std::endl;
        return false;
      }
      return true;
    }

  }
}

#endif  // ! TOPPERS_ITRONX_INIT_HELPER_HPP_
