/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */

/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tLinetracerTaskBody_template.c => src/tLinetracerTaskBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * maxTurn          int16_t          ATTR_maxTurn    
 * minTurn          int16_t          ATTR_minTurn    
 * lightThreshold   uint16_t         VAR_lightThreshold
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : cLightSensor  signature: sSensor context: task
 *   void           cLightSensor_getValue( uint16_t* value );
 * call port : cLightSensorControl  signature: sSensorControl context: task
 *   void           cLightSensorControl_on( );
 *   void           cLightSensorControl_off( );
 * call port : cBalancerControl  signature: sBalancerControl context: task
 *   void           cBalancerControl_setSpeed( int16_t speed );
 *   void           cBalancerControl_getSpeed( int16_t* speed );
 *   void           cBalancerControl_setTurn( int16_t turn );
 *   void           cBalancerControl_getTurn( int16_t* turn );
 *
 * #[</PREAMBLE>]# */

/* vg^Cv錾ϐ̒`ɏ܂ */
#include "tLinetracerTaskBody_tecsgen.h"
#include <t_syslog.h>

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tLinetracerTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	uint16_t light;
	float32_t turn_f;
	int16_t turn;

	cLightSensor_getValue(&light);
	
	if(light > (VAR_lightThreshold - 10)){
		turn = 50;
	} else {
		turn = -50;
	}

/* 	turn_f = (float32_t)(light - ATTR_lightThreshold) * 2.0;
 *
 * 	if(turn_f > (float32_t)ATTR_maxTurn){
 * 		turn = ATTR_maxTurn;
 * 	} else if(turn_f < (float32_t)ATTR_minTurn){
 * 		turn = ATTR_minTurn;
 * 	} else {
 * 		turn = (int8_t)turn_f;
 * 	}
 */
	
	cBalancerControl_setTurn(turn);
}

/* #[<ENTRY_PORT>]# eCalibrate
 * entry port: eCalibrate
 * signature:  sCalibrate
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eCalibrate_body
 * name:         eCalibrate_body
 * global_name:  tLinetracerTaskBody_eCalibrate_body
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eCalibrate_body()
{
	uint16_t light;
	
	cLightSensor_getValue(&light);
	VAR_lightThreshold = light;
	syslog(LOG_NOTICE, "light = %d", light);
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
