/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *  
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *  
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *  
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */

/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tDriverTaskBody_template.c => src/tDriverTaskBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * gyroOffset       uint16_t         ATTR_gyroOffset 
 * speed            int16_t          VAR_speed       
 * turn             int16_t          VAR_turn        
 *
 * Ăь֐ #_TCPF_#
 * call port : cLeftMotor  signature: sMotor context: task
 *   void           cLeftMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cLeftMotor_setRevolution( int32_t revolution );
 *   void           cLeftMotor_getRevolution( int32_t* revolution );
 * call port : cRightMotor  signature: sMotor context: task
 *   void           cRightMotor_setPWM( int8_t pwm, bool_t brakeMode );
 *   void           cRightMotor_setRevolution( int32_t revolution );
 *   void           cRightMotor_getRevolution( int32_t* revolution );
 * call port : cGyroSensor  signature: sSensor context: task
 *   void           cGyroSensor_getValue( uint16_t* value );
 * call port : cBattery  signature: sBattery context: task
 *   uint16_t       cBattery_getBatteryVoltage( );
 * call port : cBalancer  signature: sBalancer context: task
 *   void           cBalancer_control( int16_t forward, int16_t turn, uint16_t gyro, uint16_t gyroOffset, int32_t leftRevolution, int32_t rightRevolution, uint16_t battery, int8_t* pwm_l, int8_t* pwm_r );
 *
 * #[</PREAMBLE>]# */

#include "tDriverTaskBody_tecsgen.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eBody
 * entry port: eBody
 * signature:  sTaskBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eBody_main
 * name:         eBody_main
 * global_name:  tDriverTaskBody_eBody_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eBody_main()
{
	uint16_t gyro;          // WCZTl
	int32_t rev_l, rev_r;  // [^̉]
	int8_t  pwm_l, pwm_r;  // [^ɗ^PWMl

	/*
	 *  WCZTl̎擾
	 */
	cGyroSensor_getValue(&gyro);

	/*
	 *  [^̉]擾
	 */
	cLeftMotor_getRevolution(&rev_l);
	cRightMotor_getRevolution(&rev_r);
	
	/*
	 *  |̂߂PWMľvZ
	 */
	cBalancer_control(VAR_speed,
					  VAR_turn,
					  gyro,
					  ATTR_gyroOffset,
					  rev_l,
					  rev_r,
					  cBattery_getBatteryVoltage(),
					  &pwm_l,
					  &pwm_r);

	/*
	 *  PWMl[^ɃZbg
	 */
	cLeftMotor_setPWM(pwm_l, 1);
	cRightMotor_setPWM(pwm_r, 1);
}

/* #[<ENTRY_PORT>]# eDrive
 * entry port: eDrive
 * signature:  sDrive
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDrive_setTurn
 * name:         eDrive_setTurn
 * global_name:  tDriverTaskBody_eDrive_setTurn
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDrive_setTurn(int16_t turn)
{
	/*
	 *  turnlXV
	 */
	VAR_turn = turn;
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
