/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2009-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id:
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tSIOPortMindstormsNXT_template.c => src/tSIOPortMindstormsNXT.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * uartBase         void*            ATTR_uartBase   
 * sendBufferSize   uint32_t         ATTR_sendBufferSize
 * sendBufferPointerInitialize char_t           ATTR_sendBufferPointerInitialize
 * sendBufferCountInitialize uint32_t         ATTR_sendBufferCountInitialize
 * receiveBufferSize uint32_t         ATTR_receiveBufferSize
 * openFlag         bool_t           VAR_openFlag    
 * sendBuffer1      char_t*          VAR_sendBuffer1 
 * sendBuffer2      char_t*          VAR_sendBuffer2 
 * sendBufferPointer char_t*          VAR_sendBufferPointer
 * sendBufferCount  uint_t           VAR_sendBufferCount
 * UsedTargetbuffer bool_t           VAR_UsedTargetbuffer
 * UsedKernelbuffer bool_t           VAR_UsedKernelbuffer
 * receiveBuffer1   char_t*          VAR_receiveBuffer1
 * receiveBuffer2   char_t*          VAR_receiveBuffer2
 * receiveBufferPointer char_t*          VAR_receiveBufferPointer
 * receiveBufferCount uint32_t         VAR_receiveBufferCount
 *
 * Ăь֐ #_TCPF_#
 * require port : signature: sKernel context: task
 *   ER             sleep( );
 *   ER             sleepTimeout( TMO timeout );
 *   ER             delay( RELTIM delayTime );
 *   ER             exitTask( );
 *   ER             getTaskId( ID* p_taskId );
 *   ER             rotateReadyQueue( PRI taskPriority );
 *   ER             getTime( SYSTIM* p_systemTime );
 *   ER             getMicroTime( SYSUTM* p_systemMicroTime );
 *   ER             lockCpu( );
 *   ER             unlockCpu( );
 *   ER             disableDispatch( );
 *   ER             enableDispatch( );
 *   ER             disableTaskException( );
 *   ER             enableTaskException( );
 *   ER             changeInterruptPriorityMask( PRI interruptPriority );
 *   ER             getInterruptPriorityMask( PRI* p_interruptPriority );
 *   ER             exitKernel( );
 *   bool_t         senseContext( );
 *   bool_t         senseLock( );
 *   bool_t         senseDispatch( );
 *   bool_t         senseDispatchPendingState( );
 *   bool_t         senseKernel( );
 * call port : ciSIOCBR  signature: siSIOCBR context: task
 *   void           ciSIOCBR_readySend( );
 *   void           ciSIOCBR_readyReceive( );
 * call port : cBluetooth  signature: sBluetooth context: task
 *   void           cBluetooth_open( );
 *   bool_t         cBluetooth_getLocalAddress( uint8_t* address );
 *   bool_t         cBluetooth_getDeviceName( uint8_t* name );
 *   bool_t         cBluetooth_setDeviceName( const uint8_t* name );
 *   bool_t         cBluetooth_setFactorySetting( );
 *   uint8_t        cBluetooth_initializeMaster( const uint8_t* address );
 *   uint8_t        cBluetooth_initializeSlave( );
 *   void           cBluetooth_terminateConnection( );
 *   uint32_t       cBluetooth_sendPacket( const uint8_t* buffer, uint32_t length );
 *   uint32_t       cBluetooth_readPacket( uint8_t* buffer, uint32_t length );
 *   bool_t         cBluetooth_isConnected( );
 * call port : cSemaphore  signature: sSemaphore context: task
 *   ER             cSemaphore_signal( );
 *   ER             cSemaphore_wait( );
 *   ER             cSemaphore_waitPolling( );
 *   ER             cSemaphore_waitTimeout( TMO timeout );
 *   ER             cSemaphore_initialize( );
 *   ER             cSemaphore_refer( T_RSEM* pk_semaphoreStatus );
 *
 * #[</PREAMBLE>]# */
/*
 *		VAI/OfoCXiSIOjhCoimindstormsNXTpj
 */

#include "tSIOPortMindstormsNXT_tecsgen.h"
#include "target_serial.h"
#include "target_at91sam7s.h"
#include <t_stddef.h>
#include <t_syslog.h>
#include "syssvc/banner.h"

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

/*
 *  obt@[e[Vp[eBeB
 */
inline void
rot_target_receive_buf(CELLCB *p_cellcb)
{
	if(VAR_receiveBufferPointer == VAR_receiveBuffer1){
		VAR_receiveBufferPointer = VAR_receiveBuffer2;
	} else {
		VAR_receiveBufferPointer = VAR_receiveBuffer1;
	}
}

inline void
rot_target_send_buf(CELLCB *p_cellcb)
{
	if(VAR_sendBufferPointer == VAR_sendBuffer1) {
		VAR_sendBufferPointer = VAR_sendBuffer2;
	} else {
		VAR_sendBufferPointer = VAR_sendBuffer1;
	}
}

/*
 * M?
 * DMA]ɂC1ڂ̃obt@FULLɂȂǂԂ
 */ 
Inline bool_t
uart_getready(CELLCB *p_cellcb)
{
	return (sil_rew_mem((void*)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0);
}

/*
 *  DMA]?
 *  DMA]ȂfalseCłȂtrueԂD
 */
Inline bool_t
uart_puts_ready(CELLCB *p_cellcb)
{
	return ((sil_rew_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR)) == 0) && (sil_rew_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR)) == 0));
}

/*
 *  M̎o
 *  VDMA̎Mobt@ݒ肷
 */
Inline uint8_t
uart_getchar(CELLCB *p_cellcb)
{
	uint8_t c;
	
	if(sil_rew_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR)) == 0){
		/* Mo */
		c = VAR_receiveBufferPointer[0];

		/*
		 *  DMAɐVMobt@ݒ肷
		 *  ݒ肷obt@́CŋߕMobt@łC
		 *  1sŎgpĂobt@ł
		 */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR), VAR_receiveBufferPointer);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), ATTR_receiveBufferSize);

		/* Mobt@̃[e[V */
		rot_target_receive_buf(p_cellcb);
		
	}
	
	return c;
}

/* 
 *  DMA]Jn
 */
Inline void
uart_puts(CELLCB *p_cellcb)
{
	/*
	 *  DMARg[ɁCMf[^̃AhXƃTCYm点
	 */
	sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNPR), (uint_t)VAR_sendBufferPointer);
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_PDC_TNCR), (VAR_sendBufferCount));
}

/*
 *  M݋
 *  Mobt@󊄍
 */
Inline void
uart_enable_send(CELLCB *p_cellcb)
{
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IER), US_TXBUFE);
}

/*
 *  M݋֎~
 *  Mobt@󊄍
 */
Inline void
uart_disable_send(CELLCB *p_cellcb)
{
	sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IDR), US_TXBUFE);
}


/*
 *  M݋
 *  ENDRX  Mobt@1FULL
 */
Inline void
uart_enable_rcv(CELLCB *p_cellcb)
{
	if(cBluetooth_isConnected()){ // BluetoothʐMmĂȂOK
		sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IER), US_ENDRX);
	}
}

/*
 *  M݋֎~
 *  ENDRX  Mobt@1FULL
 */
Inline void
uart_disable_rcv(CELLCB *p_cellcb)
{
    sil_wrw_mem((void*)(ATTR_uartBase+TOFF_US_IDR), US_ENDRX);
}

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eSIOPort
 * entry port: eSIOPort
 * signature:  sSIOPort
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eSIOPort_waitReady
 * name:         eSIOPort_waitReady
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_waitReady
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eSIOPort_waitReady(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	cSemaphore_wait();
	cSemaphore_signal();
}

/* #[<ENTRY_FUNC>]# eSIOPort_isOpened
 * name:         eSIOPort_isOpened
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_isOpened
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
bool_t
eSIOPort_isOpened(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	return VAR_openFlag;
}

/* #[<ENTRY_FUNC>]# eSIOPort_open
 * name:         eSIOPort_open
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_open
 * oneway:       false
 * #[</ENTRY_FUNC>]# */

/*
 *  VAI/O|[g̃I[v
 */
void
eSIOPort_open(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	bool_t opnflg;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	opnflg = VAR_openFlag;
	
	VAR_openFlag = true;

	if(!opnflg) {
		/* M֎~ */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), (US_RXDIS | US_TXDIS));
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTDIS | PDC_TXTDIS));
		
		/*
		 *  DMA֘AWX^̏
		 */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), 0);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), 0);
		
		/*
		 *  DMAɎMpobt@ݒ肷
		 */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RPR), (uint32_t)VAR_receiveBuffer1);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), ATTR_receiveBufferSize);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNPR), (uint32_t)VAR_receiveBuffer2);
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), ATTR_receiveBufferSize);

		/* M */
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), (US_RXEN | US_TXEN));
		sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTEN | PDC_TXTEN));

		/* oi[\ */
		print_banner(0);

		/* USART݂ */
		ena_int(INTNO_SIO);
	}

	uart_enable_rcv(p_cellcb); /* M݂ */
}

/* #[<ENTRY_FUNC>]# eSIOPort_close
 * name:         eSIOPort_close
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_close
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/* 
 *  VAI/O|[g̃N[Y
 */
void
eSIOPort_close(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	sil_wrw_mem((void *)(ATTR_uartBase + TOFF_US_CR), US_RSTRX|US_RSTTX|US_RXDIS|US_TXDIS);
	
	VAR_openFlag = false;

	dis_int(INTNO_SIO);
}

/* #[<ENTRY_FUNC>]# eSIOPort_putChar
 * name:         eSIOPort_putChar
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_putChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  VAI/O|[gւ̕M
 */
bool_t
eSIOPort_putChar(CELLIDX idx, char_t c)
{
	CELLCB	*p_cellcb;

	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	if(!cBluetooth_isConnected()) { // bluetoothڑĂȂΑMłȂ
		return true; // Ȃ
	}

	/*
	 *  MsƂȂ͎1. or 2.Ƃ
	 *  1. ^[Qbgˑ̃obt@2Ƃgpł
	 *  2. ^[Qbgˑ̃obt@gpŃ^XNReLXgĂ΂ꂽ
	 */
	if(VAR_UsedTargetbuffer || (VAR_UsedKernelbuffer && (senseContext() == false))){
		return false;
	}
	
	VAR_sendBufferPointer[VAR_sendBufferCount] = c; // Mobt@ɕ
	VAR_sendBufferCount++;                        // Mobt@̕CNg

	if(c == '\n' || VAR_sendBufferCount >= ATTR_sendBufferSize) { // s̏ꍇ or Mobt@t̏ꍇ
		
		if(uart_puts_ready(p_cellcb)) { // M\ǂ`FbN
			uart_puts(p_cellcb);        // DMA]n߂

		} else {                        // DMA]
			VAR_UsedTargetbuffer = true;
			return false;               // ˑ̃obt@ɂߎn߂
		}
		
		rot_target_send_buf(p_cellcb);  // Mobt@ւ
		VAR_sendBufferCount = 0U;       // Mobt@̕Zbg
	}

	return true;
}

/* #[<ENTRY_FUNC>]# eSIOPort_getChar
 * name:         eSIOPort_getChar
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_getChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  VAI/O|[g̕M
 */
int_t
eSIOPort_getChar(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

    if (uart_getready(p_cellcb)) {
	  return((int_t)(uint8_t) uart_getchar(p_cellcb));
    }

    return(false);
}

/* #[<ENTRY_FUNC>]# eSIOPort_enableCBR
 * name:         eSIOPort_enableCBR
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_enableCBR
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  VAI/O|[g̃R[obN̋
 */
void
eSIOPort_enableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_enable_send(p_cellcb);
		VAR_UsedKernelbuffer = true; // ˑ̃obt@ɕ߂
		break;
	  case SIO_RDY_RCV:
		uart_enable_rcv(p_cellcb);
		break;
	}
}

/* #[<ENTRY_FUNC>]# eSIOPort_disableCBR
 * name:         eSIOPort_disableCBR
 * global_name:  tSIOPortMindstormsNXT_eSIOPort_disableCBR
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  VAI/O|[g̃R[obN̋֎~
 */
void
eSIOPort_disableCBR(CELLIDX idx, uint_t cbrtn)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	switch (cbrtn) {
	  case SIO_RDY_SND:
		uart_disable_send(p_cellcb);
		VAR_UsedKernelbuffer = false; // ˑ̃obt@ɕȂȂ
		break;
	  case SIO_RDY_RCV:
		uart_disable_rcv(p_cellcb);
		break;
	}
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tSIOPortMindstormsNXT_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  SIOhCȍ
 */
void
eInitialize_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	uint32_t dummy;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}
	
	/*
	 *  VAI/O|[g̏
	 */
	VAR_openFlag = false;
	
	/*
	 *  obt@̏
	 */
	VAR_sendBufferPointer = VAR_sendBuffer1;
	VAR_sendBufferCount = 0U;

	VAR_receiveBufferPointer = VAR_receiveBuffer1;
	VAR_receiveBufferCount = 0U;

	/*
	 *  UART֘AWX^̏
	 */
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), US_RSTSTA);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_CR), US_STTTO);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_RTOR), 1000);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_IDR), US_TIMEOUT);
	
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_MR), ((US_USMODE_HWHSH & ~US_SYNC) | US_CLKS_CLOCK | US_CHRL_8 | US_PAR_NO | US_NBSTOP_1 | US_OVER));
	
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_US_BRGR), ((CLOCK_RATE/8/BAUD_RATE) | (((CLOCK_RATE/8) - ((CLOCK_RATE/8/BAUD_RATE) * BAUD_RATE)) / ((BAUD_RATE + 4)/8)) << 16));

	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_PTCR), (PDC_RXTDIS | PDC_TXTDIS));

	dummy = sil_rew_mem((void *)(ATTR_uartBase+TOFF_US_RHR));
	dummy = sil_rew_mem((void *)(ATTR_uartBase+TOFF_US_CSR));
	
	/*
	 *  DMA֘AWX^̏
	 */
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RCR), 0);
	sil_wrw_mem((void *)(ATTR_uartBase+TOFF_PDC_RNCR), 0);
}

/* #[<ENTRY_PORT>]# eTerminate
 * entry port: eTerminate
 * signature:  sTerminateRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTerminate_main
 * name:         eTerminate_main
 * global_name:  tSIOPortMindstormsNXT_eTerminate_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  SIOhCȍI
 */
void
eTerminate_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if (VALID_IDX(idx)) {
		p_cellcb = GET_CELLCB(idx);
	}

	/*
	 *  I[vĂVAI/O|[g̃N[Y
	 */
	if (VAR_openFlag) {
		/*
		 *  CuŏIs
		 */
		VAR_openFlag = false;
		/*
		 *  VAI/O݂}XND
		 */
		dis_int(INTNO_SIO);
	}
}


/* #[<ENTRY_PORT>]# eiISR
 * entry port: eiISR
 * signature:  siHandlerBody
 * context:    non-task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eiISR_main
 * name:         eiISR_main
 * global_name:  tSIOPortMindstormsNXT_eiISR_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
/*
 *  SIO̊݃T[rX[`
 *  mindstormsNXTłbluetoothɐڑĂUART̃|[g1
 *  Ȃ߁C჌xo͂ƕWo͂ɂāCUART
 *  |[gLĂD
 *  ჌xo͂DMA]҂ƁCWo͂łDMA]҂
 *  NƁC჌xo͂DMA]1񕪒x\D
 *  F@@჌xo͂DMA҂
 *     @Wo͂DMA҂
 *     @ISRŕWo͂DMA]Jn
 *     @჌xo͂łȂCWo͂D悵ĎsĂ܂
 */
void
eiISR_main(CELLIDX idx)
{
	CELLCB	*p_cellcb;
	if(VALID_IDX(idx)){
		p_cellcb = GET_CELLCB(idx);
	}

	/* DMAɂobt@VA|[gւ̑MƂ */
	if(uart_puts_ready(p_cellcb)){ // DMA]I
		if(VAR_UsedTargetbuffer){            // ˑ̃obt@ɕ
			uart_puts(p_cellcb);           // 𑗐M
			rot_target_send_buf(p_cellcb); // obt@ؑւ
			VAR_sendBufferCount = 0U;      // |C^̏
			VAR_UsedTargetbuffer = false;
		} else {                           // ˑ̃obt@ɕ
			ciSIOCBR_readySend();
		}
	}

	/* DMAŃVA|[gobt@1MƂ */
	while(uart_getready(p_cellcb)){
		ciSIOCBR_readyReceive();
	}
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
