/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *   Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *               Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *   L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *   Ai{\tgEFAς̂܂ށDȉjgpEE
 *   ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *   (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *       \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *       XR[hɊ܂܂Ă邱ƁD
 *   (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *       pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *       ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *       ̖ۏ؋Kfڂ邱ƁD
 *   (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *       płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *       ƁD
 *     (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *         쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *     (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *         񍐂邱ƁD
 *   (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *       QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *       ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *       RɊÂCL쌠҂TOPPERSvWFNg
 *       Ɛӂ邱ƁD
 *
 *   {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *   TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *   ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *   A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *   ̐ӔC𕉂ȂD
 *
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tButtonBody_inline_template.h => src/tButtonBody_inline.h
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * threshold        int32_t          ATTR_threshold  
 * button           uint8_t          VAR_button      
 * count            int32_t          VAR_count       
 * preState         uint8_t          VAR_preState    
 *
 * #[</PREAMBLE>]# */

#define BUTTON_ENTER 0x01
#define BUTTON_STOP  0x02
#define BUTTON_RUN   0x04
#define BUTTON_EXIT  0x08

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eButton
 * entry port: eButton
 * signature:  sButton
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eButton_isENTERButton
 * name:         eButton_isENTERButton
 * global_name:  tButtonBody_eButton_isENTERButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isENTERButton()
{
    return ((VAR_button & BUTTON_ENTER) == BUTTON_ENTER);
}

/* #[<ENTRY_FUNC>]# eButton_isRUNButton
 * name:         eButton_isRUNButton
 * global_name:  tButtonBody_eButton_isRUNButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isRUNButton()
{
    return ((VAR_button & BUTTON_RUN) == BUTTON_RUN);
}

/* #[<ENTRY_FUNC>]# eButton_isSTOPButton
 * name:         eButton_isSTOPButton
 * global_name:  tButtonBody_eButton_isSTOPButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isSTOPButton()
{
    return ((VAR_button & BUTTON_STOP) == BUTTON_STOP);
}

/* #[<ENTRY_FUNC>]# eButton_isEXITButton
 * name:         eButton_isEXITButton
 * global_name:  tButtonBody_eButton_isEXITButton
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isEXITButton()
{
    return ((VAR_button & BUTTON_EXIT) == BUTTON_EXIT);
}

/* #[<ENTRY_FUNC>]# eButton_isENTERButtonOnly
 * name:         eButton_isENTERButtonOnly
 * global_name:  tButtonBody_eButton_isENTERButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isENTERButtonOnly()
{
    return (VAR_button == BUTTON_ENTER);
}

/* #[<ENTRY_FUNC>]# eButton_isRUNButtonOnly
 * name:         eButton_isRUNButtonOnly
 * global_name:  tButtonBody_eButton_isRUNButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isRUNButtonOnly()
{
    return (VAR_button == BUTTON_RUN);
}

/* #[<ENTRY_FUNC>]# eButton_isSTOPButtonOnly
 * name:         eButton_isSTOPButtonOnly
 * global_name:  tButtonBody_eButton_isSTOPButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isSTOPButtonOnly()
{
    return (VAR_button == BUTTON_STOP);
}

/* #[<ENTRY_FUNC>]# eButton_isEXITButtonOnly
 * name:         eButton_isEXITButtonOnly
 * global_name:  tButtonBody_eButton_isEXITButtonOnly
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
Inline bool_t
eButton_isEXITButtonOnly()
{
    return (VAR_button == BUTTON_EXIT);
}

