/*
 * original:lejos-osek/src/nxtvm/platform/nxt/display.c rev.1.1.1.1
 * modified history.
 * 05/23/2011: Modifier Takuya Ishikawa
 * 05/24/2010: Modifier Takuya Ishikawa
 *           : Changed interface name to entry function name with TECS nameing rule
 *           : Modified initialize to
 *               display_clear(0); -> memset(...);;
 *               lcd_init(...); -> initialize(...); powerOn(...);
 *           : Added interface to powerOff(clear and powerOff lcd)
 *           : Changed display_unsigned_worker to display_convert
 *           : Modified putChar to plus currentX
 *           : Modified some variables to component variables
 *           : Modified some constants to component attributes
 *           : Modified data type to ITRON spec.
 * 04/03/2010: Modifider Ryosuke Takeuchi
 *           : Modified Device Interface to ITRON-SIL interface and Changed
 *             AT91SAM7.h to SIL defined include file.
 *           : Modified systick_wait_ms function to ITRON dly_tsk servec call function. 
 *           : Modified display_init function argument to ITRON ATT static API type.
 *           : Added spi refresh function.(display_refresh).
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tDisplayBody_template.c => src/tDisplayBody.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * width            uint8_t          ATTR_width      
 * depth            uint8_t          ATTR_depth      
 * cellWidth        uint8_t          ATTR_cellWidth  
 * charWidth        uint8_t          ATTR_charWidth  
 * charDepth        uint8_t          ATTR_charDepth  
 * buffer           uint8_t*         VAR_buffer      
 * currentX         uint8_t          VAR_currentX    
 * currentY         uint8_t          VAR_currentY    
 *
 * Ăь֐ #_TCPF_#
 * call port : cLCD  signature: sLCD context: task
 *   void           cLCD_initialize( const uint8_t* display );
 *   void           cLCD_powerOn( const uint8_t* display );
 *   void           cLCD_powerOff( );
 *   void           cLCD_sendData( const uint8_t* buffer );
 *
 * #[</PREAMBLE>]# */

#include "tDisplayBody_tecsgen.h"
#include <sil.h>

/*
 *  e\邽߂̒`
 *  [size_is(5 * 128)]
 */
static const uint8_t font[] = {
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x00 */
    0x3E, 0x55, 0x61, 0x55, 0x3E,/* 0x01 */
    0x3E, 0x6B, 0x5F, 0x6B, 0x3E,/* 0x02 */
    0x0C, 0x1E, 0x3C, 0x1E, 0x0C,/* 0x03 */
    0x08, 0x1C, 0x3E, 0x1C, 0x08,/* 0x04 */
    0x18, 0x5E, 0x7E, 0x5E, 0x18,/* 0x05 */
    0x18, 0x5C, 0x7E, 0x5C, 0x18,/* 0x06 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x07 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x08 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x09 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x0A */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x0B */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x0C */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x0D */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x0E */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x0F */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x10 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x11 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x12 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x13 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x14 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x15 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x16 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x17 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x18 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x19 */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x1A */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x1B */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x1C */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x1D */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x1E */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x1F */
    0x00, 0x00, 0x00, 0x00, 0x00,/* 0x20 */
    0x00, 0x00, 0x5F, 0x00, 0x00,/* 0x21 */
    0x00, 0x07, 0x00, 0x07, 0x00,/* 0x22 */
    0x14, 0x3E, 0x14, 0x3E, 0x14,/* 0x23 */
    0x04, 0x2A, 0x7F, 0x2A, 0x10,/* 0x24 */
    0x26, 0x16, 0x08, 0x34, 0x32,/* 0x25 */
    0x36, 0x49, 0x59, 0x26, 0x50,/* 0x26 */
    0x00, 0x00, 0x07, 0x00, 0x00,/* 0x27 */
    0x00, 0x1C, 0x22, 0x41, 0x00,/* 0x28 */
    0x00, 0x41, 0x22, 0x1C, 0x00,/* 0x29 */
    0x2A, 0x1C, 0x7F, 0x1C, 0x2A,/* 0x2A */
    0x08, 0x08, 0x3E, 0x08, 0x08,/* 0x2B */
    0x00, 0x50, 0x30, 0x00, 0x00,/* 0x2C */
    0x08, 0x08, 0x08, 0x08, 0x08,/* 0x2D */
    0x00, 0x60, 0x60, 0x00, 0x00,/* 0x2E */
    0x20, 0x10, 0x08, 0x04, 0x02,/* 0x2F */
    0x3E, 0x51, 0x49, 0x45, 0x3E,/* 0x30 */
    0x00, 0x42, 0x7F, 0x40, 0x00,/* 0x31 */
    0x42, 0x61, 0x51, 0x49, 0x46,/* 0x32 */
    0x21, 0x41, 0x45, 0x4B, 0x31,/* 0x33 */
    0x18, 0x14, 0x12, 0x7F, 0x10,/* 0x34 */
    0x27, 0x45, 0x45, 0x45, 0x39,/* 0x35 */
    0x3C, 0x4A, 0x49, 0x49, 0x30,/* 0x36 */
    0x01, 0x01, 0x79, 0x05, 0x03,/* 0x37 */
    0x36, 0x49, 0x49, 0x49, 0x36,/* 0x38 */
    0x06, 0x49, 0x49, 0x29, 0x1E,/* 0x39 */
    0x00, 0x36, 0x36, 0x00, 0x00,/* 0x3A */
    0x00, 0x56, 0x36, 0x00, 0x00,/* 0x3B */
    0x08, 0x14, 0x22, 0x41, 0x00,/* 0x3C */
    0x14, 0x14, 0x14, 0x14, 0x14,/* 0x3D */
    0x41, 0x22, 0x14, 0x08, 0x00,/* 0x3E */
    0x02, 0x01, 0x59, 0x05, 0x02,/* 0x3F */
    0x1C, 0x2A, 0x36, 0x3E, 0x0C,/* 0x40 */
    0x7E, 0x09, 0x09, 0x09, 0x7E,/* 0x41 */
    0x7F, 0x49, 0x49, 0x49, 0x3E,/* 0x42 */
    0x3E, 0x41, 0x41, 0x41, 0x22,/* 0x43 */
    0x7F, 0x41, 0x41, 0x22, 0x1C,/* 0x44 */
    0x7F, 0x49, 0x49, 0x49, 0x41,/* 0x45 */
    0x7F, 0x09, 0x09, 0x09, 0x01,/* 0x46 */
    0x3E, 0x41, 0x41, 0x49, 0x3A,/* 0x47 */
    0x7F, 0x08, 0x08, 0x08, 0x7F,/* 0x48 */
    0x00, 0x41, 0x7F, 0x41, 0x00,/* 0x49 */
    0x20, 0x40, 0x41, 0x3F, 0x01,/* 0x4A */
    0x7F, 0x08, 0x14, 0x22, 0x41,/* 0x4B */
    0x7F, 0x40, 0x40, 0x40, 0x40,/* 0x4C */
    0x7F, 0x02, 0x04, 0x02, 0x7F,/* 0x4D */
    0x7F, 0x04, 0x08, 0x10, 0x7F,/* 0x4E */
    0x3E, 0x41, 0x41, 0x41, 0x3E,/* 0x4F */
    0x7F, 0x09, 0x09, 0x09, 0x06,/* 0x50 */
    0x3E, 0x41, 0x51, 0x21, 0x5E,/* 0x51 */
    0x7F, 0x09, 0x19, 0x29, 0x46,/* 0x52 */
    0x26, 0x49, 0x49, 0x49, 0x32,/* 0x53 */
    0x01, 0x01, 0x7F, 0x01, 0x01,/* 0x54 */
    0x3F, 0x40, 0x40, 0x40, 0x3F,/* 0x55 */
    0x1F, 0x20, 0x40, 0x20, 0x1F,/* 0x56 */
    0x7F, 0x20, 0x18, 0x20, 0x7F,/* 0x57 */
    0x63, 0x14, 0x08, 0x14, 0x63,/* 0x58 */
    0x03, 0x04, 0x78, 0x04, 0x03,/* 0x59 */
    0x61, 0x51, 0x49, 0x45, 0x43,/* 0x5A */
    0x00, 0x7F, 0x41, 0x41, 0x00,/* 0x5B */
    0x02, 0x04, 0x08, 0x10, 0x20,/* 0x5C */
    0x00, 0x41, 0x41, 0x7F, 0x00,/* 0x5D */
    0x04, 0x02, 0x01, 0x02, 0x04,/* 0x5E */
    0x40, 0x40, 0x40, 0x40, 0x40,/* 0x5F */
    0x00, 0x00, 0x07, 0x00, 0x00,/* 0x60 */
    0x20, 0x54, 0x54, 0x54, 0x78,/* 0x61 */
    0x7f, 0x48, 0x44, 0x44, 0x38,/* 0x62 */
    0x30, 0x48, 0x48, 0x48, 0x20,/* 0x63 */
    0x38, 0x44, 0x44, 0x48, 0x7f,/* 0x64 */
    0x38, 0x54, 0x54, 0x54, 0x18,/* 0x65 */
    0x08, 0x7e, 0x09, 0x09, 0x02,/* 0x66 */
    0x0c, 0x52, 0x52, 0x52, 0x3e,/* 0x67 */
    0x7f, 0x08, 0x04, 0x04, 0x78,/* 0x68 */
    0x00, 0x44, 0x7d, 0x40, 0x00,/* 0x69 */
    0x20, 0x40, 0x40, 0x3d, 0x00,/* 0x6A */
    0x7f, 0x10, 0x28, 0x44, 0x00,/* 0x6B */
    0x00, 0x41, 0x7f, 0x40, 0x00,/* 0x6C */
    0x7c, 0x04, 0x18, 0x04, 0x78,/* 0x6D */
    0x7c, 0x08, 0x04, 0x04, 0x78,/* 0x6E */
    0x38, 0x44, 0x44, 0x44, 0x38,/* 0x6F */
    0xfc, 0x14, 0x14, 0x14, 0x08,/* 0x70 */
    0x08, 0x14, 0x14, 0x18, 0x7c,/* 0x71 */
    0x7c, 0x08, 0x04, 0x04, 0x08,/* 0x72 */
    0x48, 0x54, 0x54, 0x54, 0x20,/* 0x73 */
    0x04, 0x3f, 0x44, 0x40, 0x20,/* 0x74 */
    0x3c, 0x40, 0x40, 0x20, 0x7c,/* 0x75 */
    0x1c, 0x20, 0x40, 0x20, 0x1c,/* 0x76 */
    0x3c, 0x40, 0x38, 0x40, 0x3c,/* 0x77 */
    0x44, 0x28, 0x10, 0x28, 0x44,/* 0x78 */
    0x0c, 0x50, 0x50, 0x50, 0x3c,/* 0x79 */
    0x44, 0x64, 0x54, 0x4c, 0x44,/* 0x7A */
    0x00, 0x08, 0x36, 0x41, 0x00,/* 0x7B */
    0x00, 0x00, 0x7F, 0x00, 0x00,/* 0x7C */
    0x00, 0x41, 0x36, 0x08, 0x00,/* 0x7D */
    0x00, 0x07, 0x00, 0x07, 0x00,/* 0x7E */
    0x3E, 0x36, 0x2A, 0x36, 0x3E,/* 0x7F */
};

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif

static inline void
display_putchar(uint8_t c)
{
    uint8_t *tmpBuffer;
    int32_t i;

    if(c >= 0 && c < 128 &&
       VAR_currentX >= 0 && VAR_currentX < ATTR_charWidth &&
       VAR_currentY >= 0 && VAR_currentY < ATTR_charDepth){
        tmpBuffer = &VAR_buffer[VAR_currentY * ATTR_width + VAR_currentX * ATTR_cellWidth];

        for(i = 0; i < (ATTR_cellWidth - 1); i++){
            *tmpBuffer = font[c * 5 + i];
            tmpBuffer++;
        }
        
        VAR_currentX++;
    }
}

static const char_t raddec[] = "0123456789";
static const char_t radHEX[] = "0123456789ABCDEF";

static inline void
display_convert(uintptr_t val, uint_t radix, const char_t *radchar, 
                uint8_t places, bool_t minus)
{
    uint8_t digitBuffer[ATTR_charWidth - 2];
    int8_t i = 0;

    /*
     *  ŉʌ̐珇Ƀobt@Ɋi[
     */
    do{
        if(i > (ATTR_charWidth - 2)){
            break;
        }
        
        digitBuffer[i++] = radchar[val % radix];
        val /= radix;
    } while(val);

    /*
     *  Ȃ𖄂߂
     */
    while((i + minus) < places){
        if(radix == 10){ // 10i
            display_putchar(' ');
        } else { // 16i
            display_putchar('0');
        }
        places--;
    }

    /*
     *  ϊfBXvCɕ\
     */
    if(minus){
        display_putchar('-');
    }
    while(i > 0){
        display_putchar(digitBuffer[--i]);
    }
}

/* 󂯌֐ #_TEPF_# */
/* #[<ENTRY_PORT>]# eDisplay
 * entry port: eDisplay
 * signature:  sDisplay
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eDisplay_update
 * name:         eDisplay_update
 * global_name:  tDisplayBody_eDisplay_update
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_update()
{
    cLCD_sendData((uint8_t *) VAR_buffer);
}

/* #[<ENTRY_FUNC>]# eDisplay_clear
 * name:         eDisplay_clear
 * global_name:  tDisplayBody_eDisplay_clear
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_clear(bool_t updateToo)
{
    int16_t i;

    for(i = 0; i < ATTR_depth*ATTR_width; i++){
        VAR_buffer[i] = 0;
    }

    if(updateToo){
        cLCD_sendData((uint8_t *) VAR_buffer);
    }
}

/* #[<ENTRY_FUNC>]# eDisplay_gotoXY
 * name:         eDisplay_gotoXY
 * global_name:  tDisplayBody_eDisplay_gotoXY
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_gotoXY(uint8_t x, uint8_t y)
{
    VAR_currentX = x;
    VAR_currentY = y;
}

/* #[<ENTRY_FUNC>]# eDisplay_putChar
 * name:         eDisplay_putChar
 * global_name:  tDisplayBody_eDisplay_putChar
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_putChar(char_t c)
{
    display_putchar(c);
}

/* #[<ENTRY_FUNC>]# eDisplay_putString
 * name:         eDisplay_putString
 * global_name:  tDisplayBody_eDisplay_putString
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_putString(const char_t* string)
{
    while(*string){
        if(*string != '\n'){ /* s */
            display_putchar(*string);
        } else{
            VAR_currentX = 0;
            VAR_currentY++;
        }
        
        string++;
    }
}

/* #[<ENTRY_FUNC>]# eDisplay_putInt
 * name:         eDisplay_putInt
 * global_name:  tDisplayBody_eDisplay_putInt
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_putInt(int32_t val, uint8_t places)
{
    /*
     *  ̗L
     */
    if(val >= 0){
        display_convert(val, 10, raddec, places, false);
    } else {
        display_convert((-1 * val), 10, raddec, places, true);
    }
}

/* #[<ENTRY_FUNC>]# eDisplay_putUnsigned
 * name:         eDisplay_putUnsigned
 * global_name:  tDisplayBody_eDisplay_putUnsigned
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_putUnsigned(uint32_t val, uint8_t places)
{
    display_convert(val, 10, raddec, places, false);
}

/* #[<ENTRY_FUNC>]# eDisplay_putHex
 * name:         eDisplay_putHex
 * global_name:  tDisplayBody_eDisplay_putHex
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_putHex(uint32_t val, uint8_t places)
{
    display_convert(val, 16, radHEX, places, false);
}

/* #[<ENTRY_FUNC>]# eDisplay_getBuffer
 * name:         eDisplay_getBuffer
 * global_name:  tDisplayBody_eDisplay_getBuffer
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
uint8_t*
eDisplay_getBuffer()
{
    return VAR_buffer;
}

static inline void
display_poweroff()
{
    int16_t i;

    for(i = 0; i < ATTR_depth*ATTR_width; i++){
        VAR_buffer[i] = 0;
    }

    cLCD_sendData(VAR_buffer);

    sil_dly_nse(10*1000*1000);
    cLCD_powerOff();
    sil_dly_nse(10*1000*1000);
}

/* #[<ENTRY_FUNC>]# eDisplay_powerOff
 * name:         eDisplay_powerOff
 * global_name:  tDisplayBody_eDisplay_powerOff
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eDisplay_powerOff(bool_t updateToo)
{
    display_poweroff();
}

/* #[<ENTRY_PORT>]# eInitialize
 * entry port: eInitialize
 * signature:  sInitializeRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eInitialize_main
 * name:         eInitialize_main
 * global_name:  tDisplayBody_eInitialize_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eInitialize_main()
{
    sil_dly_nse(1000*1000*1000);
    /*
     *  obt@NA
     */
    memset(VAR_buffer, 0, ATTR_depth*ATTR_width);

    /*
     *  LCD
     */
    cLCD_initialize((uint8_t *)VAR_buffer);
    cLCD_powerOn((uint8_t *)VAR_buffer);
}

/* #[<ENTRY_PORT>]# eTerminate
 * entry port: eTerminate
 * signature:  sTerminateRoutineBody
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eTerminate_main
 * name:         eTerminate_main
 * global_name:  tDisplayBody_eTerminate_main
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void
eTerminate_main()
{
    /* 
     *  ŏĂԂƁC~Ă܂ƂD
     */
    //display_poweroff();
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
