/*
 *   TOPPERS Software
 *       Toyohashi Open Platform for Embedded Real-Time Systems
 *
 *  Copyright (C) 2010-2011 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 *
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 *
 *  @(#) $Id:
 */
/*
 * ̃t@C tecsgen ɂev[gƂĎ܂
 * ̃t@CҏWĎgp邱ƂӐ}Ă܂
 * tecsgen ̍Ďsɂ㏑Ă܂߁Aʏ
 *   gen/tFlash_template.c => src/tFlash.c
 * ̂悤ɖO, tH_ύXĂC܂
 */
/* #[<PREAMBLE>]#
 * #[<...>]#  #[</...>]# ň͂܂ꂽRg͕ҏWȂł
 * tecsmerge ɂ}[WɎgp܂
 *
 * ANZX}N #_CAAM_#
 * startAddress     volatile uint32_t*  ATTR_startAddress
 * requestStartPage uint32_t         ATTR_requestStartPage
 * requestData      char_t*          ATTR_requestData
 * flashBase        volatile uint32_t*  ATTR_flashBase
 * flashCommand     volatile uint32_t*  ATTR_flashCommand
 * flashStatus      volatile uint32_t*  ATTR_flashStatus
 * pageSize         uint32_t         ATTR_pageSize
 * flashStatusRam   volatile uint32_t*  VAR_flashStatusRam
 *
 * Ăь֐ #_TCPF_#
 * call port : cTerminate  signature: sTerminateRoutineBody context: task
 *   void           cTerminate_main( );
 *
 * #[</PREAMBLE>]# */

#include "tFlash_tecsgen.h"
#include <sil.h>

static const char_t requestData[] = "Jumpin' Jack Flash";

#ifndef E_OK
#define	E_OK	0		/* success */
#define	E_ID	(-18)	/* illegal ID */
#endif


/* #[<ENTRY_PORT>]# eFlash
 * entry port: eFlash
 * signature:  sFlash
 * context:    task
 * #[</ENTRY_PORT>]# */

/* #[<ENTRY_FUNC>]# eFlash_rewriteBios
 * name:         eFlash_rewriteBios
 * global_name:  tFlash_eFlash_rewriteBios
 * oneway:       false
 * #[</ENTRY_FUNC>]# */
void eFlash_rewriteBios() __attribute__((section(".text_ram")));

void
eFlash_rewriteBios()
{
    uint32_t request[ATTR_pageSize];
    int32_t i;

    /*
     *  Flash̏vf[^
     */
    memset(request, 0, ATTR_pageSize);
    strncpy((char_t *)request, requestData, ATTR_pageSize*4);

    SIL_PRE_LOC;

    /*
     *  ݋֎~
     */
    SIL_LOC_INT();

    sil_dly_nse(10*1000*1000);

    /*
     *  FlashRg[󂭂܂ő҂
     */
    while(!(sil_rew_mem((void *)ATTR_flashStatus) & 0x1));

    for(i = 0; i < ATTR_pageSize; i++){
        ATTR_flashBase[i] = request[i];
    }

    /*
     *  FlashRg[ɏv𔭍s
     */
    sil_wrw_mem((void *)(ATTR_flashCommand),
                (0x5A000001 + (((ATTR_requestStartPage) & 0x000003FF) << 8)));

    /*
     *  ȍ~̃R[h́CROMɒuĂ͂Ȃ
     */
    while(!(sil_rew_mem((void *)VAR_flashStatusRam) & 0x1));

    sil_dly_nse(10*1000*1000);

    /*
     * IĂ
     */
    cTerminate_main();
}

/* #[<POSTAMBLE>]#
 *   艺ɔ󂯌֐܂
 * #[</POSTAMBLE>]#*/
