#
#  TECS Generator
#      Generator for TOPPERS Embedded Component System
#  
#   Copyright (C) 2008-2011 by TOPPERS Project
#--
#   嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
#   ܥեȥѤΤޤࡥʲƱˤѡʣ
#   ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
#   (1) ܥեȥ򥽡ɤηѤˤϡ嵭
#       ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
#       ˴ޤޤƤ뤳ȡ
#   (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
#       ѤǤǺۤˤϡۤȼɥȡ
#       ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
#       ̵ݾڵǺܤ뤳ȡ
#   (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
#       ѤǤʤǺۤˤϡΤ줫ξ
#       ȡ
#     (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
#         ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
#     (b) ۤη֤̤ˡˤäơTOPPERSץȤ
#         𤹤뤳ȡ
#   (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
#       ⡤嵭ԤTOPPERSץȤդ뤳ȡ
#       ޤܥեȥΥ桼ޤϥɥ桼Τʤ
#       ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
#       դ뤳ȡ
#  
#   ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
#   TOPPERSץȤϡܥեȥ˴ؤơλŪ
#   ФŬޤơʤݾڤԤʤޤܥեȥ
#   ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
#   Ǥʤ
#  
#   $Id: GenTransparentMarshaler.rb 1237 2011-01-29 05:43:02Z okuma-top $
#++

#ץ饰󥪥ץѿ
#@task_priority:: Integer
#@channelCelltype:: String
#@channelCellName:: String
#@PPAllocatorSize:: Integer
module GenTransparentMarshaler

  # ץ饰̾ Proc
  RPCPluginArgProc = {
    "taskPriority"    => Proc.new { |obj,rhs| obj.set_taskPriority rhs },
    "channelCelltype" => Proc.new { |obj,rhs| obj.set_channelCelltype rhs },
    "TDRCelltype"     => Proc.new { |obj,rhs| obj.set_TDRCelltype rhs },
    "channelCellName" => Proc.new { |obj,rhs| obj.set_channelCellName rhs },
    "PPAllocatorSize" => Proc.new { |obj,rhs| obj.set_PPAllocatorSize rhs },
  }

  #=== ץ饰 taskPriority Υå
  def set_taskPriority( rhs )
    @task_priority = rhs
  end

  #=== ץ饰 channelCelltype Υå
  def set_channelCelltype( rhs )
    @channelCelltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: channeclCelltype '#{rhs}' not celltype or not found" )
    end
  end

  #=== ץ饰 TDRCelltype Υå
  def set_TDRCelltype( rhs )
    @TDRCelltype = rhs
    path = [ "::", rhs ]
    obj = Namespace.find( path )
    if ! obj.instance_of?( Celltype ) && ! obj.instance_of?( CompositeCelltype ) then
      Generator.error( "RPCPlugin: TDRCelltype '#{rhs}' not celltype or not found" )
    end
  end

  #=== ץ饰 channelCellName Υå
  def set_channelCellName( rhs )
    @channelCellName = rhs
    if @channelCellName =~ /\A[a-zA-Z_]\w*/ then
      # OK
    else
      Generator.error( "RPCPlugin: channeclCellName '#{rhs}' unsuitable for identifier" )
    end
  end

  #=== ץ饰 PPAllocatorSize Υå
  def set_PPAllocatorSize( rhs )
    @PPAllocatorSize = rhs
  end

  #=== marshaler Υ륿̾ꤹ
  def initialize_transparent_marshaler cell_name
    @task_priority = 8
    @channelCelltype = "tDataqueueOWChannel"
    @TDRCelltype     = "tTDR"
    @channelCellName = "#{cell_name}_Channel"
    @PPAllocatorSize = nil

    @marshaler_celltype_name = "tMarshaler_#{@signature.get_name}"
    @unmarshaler_celltype_name = "tUnmarshaler_#{@signature.get_name}"
    @marshaler_celltype_file_name = "#{$gen}/#{@marshaler_celltype_name}.cdl"
  end

  def gen_marshaler_celltype 

    if @PPAllocatorSize then
      alloc_call_port = "  call sPPAllocator cPPAllocator;\n"
    else
      alloc_call_port = ""
    end

    f = CFile.open( @marshaler_celltype_file_name, "w" )
    # ƱƤٽ񤯲ǽ (AppFile Բ)

    f.print <<EOT

celltype #{@marshaler_celltype_name} {
  entry #{@signature.get_name} eClientEntry;
  call sTDR        cTDR;
  call sEventflag  cEventflag;
  [optional]
    call sSemaphore cLockChannel;  // this port is eliminated by optimize
};
celltype #{@unmarshaler_celltype_name} {
  call #{@signature.get_name} cServerCall;
  call sTDR        cTDR;
  call sEventflag  cEventflag;
  entry sTaskBody  eUnmarshalAndCallFunction;
#{alloc_call_port}};
EOT
    f.close
  end

  #===  ؿΥɤƬӽϡ
  #ct_name:: Symbol    (through ץ饰줿) 륿̾ Symbol ȤƤʤ餷
  def gen_ep_func_body( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    # unmarshaler 饹?
    if ct_name == @unmarshaler_celltype_name.to_sym then
      gen_ep_func_body_unmarshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
    else
      gen_ep_func_body_marshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )
    end
  end

  #===  marshal ɤ
  def gen_ep_func_body_marshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

    b_void = false
    b_ret_er = false

    # ؿͤθη(typedef Ƥ)
    type = func_type.get_type.get_original_type

    # ͵Ѥѿϡvoid δؿǤϽϤʤ
    if ! type.kind_of?( VoidType ) then
      file.print( "    #{func_type.get_type.get_type_str}  retval_;\n" )
      if func_type.get_type.kind_of?( DefinedType ) && ( func_type.get_type.get_type_str == "ER" || func_type.get_type.get_type_str == "ER_INT" ) then
        b_ret_er = true
      end
    else
      b_void = true
    end

    file.print( "    ER      ercd_;\n" )
    file.print( "    FLGPTN  flgptn;\n" )

    # Ƥ signature Ф
    signature = @signature

    # ؿ ID ͡
    func_id = signature.get_id_from_func_name( func_name )
    file.print( "    int16_t  func_id_ = #{func_id};    /* id of #{func_name}: #{func_id} */\n" )

    # 󥰥ȥǤʤ
    if ! b_singleton then

      # singleton Ǥʤ p_cellcb ɤ
      file.print <<EOT
    #{ct_name}_CB *p_cellcb;

    if( VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
EOT

      # 顼֤
      if b_ret_er then
        file.print <<EOT
    }else{
         return ERCD( E_RPC, E_ID );
    }
EOT
      else
        file.print <<EOT
    }else{
        /* 顼ɤ򤳤˵ */
    }
EOT
      end
    end

    # channel lock 
    file.print <<EOT
    /* Channel Lock */
    if( is_cLockChannel_joined() )
      cLockChannel_wait();

EOT

    # SOP 
    file.print "    /* SOP */\n"
    file.print "    if( ( ercd_ = cTDR_sendSOP( true ) ) != E_OK )\n"
    file.print "      goto error_reset;\n"

    # func_id 
    file.print "    /* ؿ id  */\n"
    file.print "    if( ( ercd_ = cTDR_putInt16( func_id_ ) ) != E_OK )\n"
    file.print "        goto error_reset;\n"

    # p "celltype_name, sig_name, func_name, func_global_name"
    # p "#{ct_name}, #{sig_name}, #{func_name}, #{func_global_name}"

    b_get = false    # marshal ʤ put
    b_marshal = true  # marshal

    # in Ϥ
    file.print "    /* ϰ */\n"
    print_params( params, file, 1, b_marshal, b_get, true, func_type.is_oneway? )
    print_params( params, file, 1, b_marshal, b_get, false, func_type.is_oneway? )
    if ! b_void && ! func_type.is_oneway? then
      ret_ptr_type = PtrType.new( func_type.get_type )
      print_param_nc( "retval_", ret_ptr_type, file, 1, :RETURN, "&", nil, b_get )
    end

    file.print "    /* EOPСʥѥåȤݤ */\n"
    if ! func_type.is_oneway? then
      b_continue = "true"
    else
      b_continue = "false"
    end
    file.print "    if( (ercd_=cTDR_sendEOP(#{b_continue})) != E_OK )\n"
    file.print "        goto error_reset;\n\n"

    if ! func_type.is_oneway? then
      file.print <<EOT
    if( (ercd_=cEventflag_wait( 0x01, TWF_ANDW, &flgptn )) != E_OK ){
      ercd_ = ERCD(E_RPC,ercd_);
      goto error_reset;
    }
    if( (ercd_=cEventflag_clear( 0x00 ) ) != E_OK ){
      ercd_ = ERCD(E_RPC,ercd_);
      goto error_reset;
    }
EOT
    end # ! func_type.is_oneway?

    file.print <<EOT
    /* Channel Lock */
    if( is_cLockChannel_joined() )
      cLockChannel_signal();
EOT

    if( b_void == false )then
      # ƤӸͤ꥿
      file.print( "    return retval_;\n" )
    else
      file.print( "    return;\n" )
    end

    file.print <<EOT

error_reset:
    if( ercd_ != ERCD( E_RPC, E_RESET ) )
        (void)cTDR_reset();
EOT

    # channel lock 
    file.print <<EOT
    /* Channel Lock */
    if( is_cLockChannel_joined() )
      cLockChannel_signal();

EOT

    if( b_ret_er != false )then
      # ƤӸͤ꥿
      file.print( "    return ercd_;\n" )
    else
      file.print( "    return;\n" )
    end

  end

  #===  unmarshal ɤ
  def gen_ep_func_body_unmarshal( file, b_singleton, ct_name, global_ct_name, sig_name, ep_name, func_name, func_global_name, func_type, params )

#    b_ret_er = true
    b_ret_er = false

    # func_id 륳ɤ
    file.print <<EOT

    int16_t   func_id_;
    ER        ercd_;

    #{ct_name}_CB *p_cellcb;

    if( VALID_IDX( idx ) ){
        p_cellcb = GET_CELLCB(idx);
EOT

    if b_ret_er then
        file.print <<EOT
    }else{
        return ERCD( E_RPC, E_ID );
    }
EOT
    else
        file.print <<EOT
    }else{
        /* 顼ɤ򤳤˵ */
    }
EOT
    end

    file.print <<EOT

    /* SOPΥå */
    if( (ercd_=cTDR_receiveSOP( false )) != E_OK )
        goto error_reset;
    /* func_id μ */
    if( (ercd_=cTDR_getInt16( &func_id_ )) != E_OK )
        goto error_reset;

#ifdef RPC_DEBUG
    syslog(LOG_INFO, "unmarshaler task: func_id: %d", func_id_ );
#endif
    switch( func_id_ ){
EOT

    # Ƥ signature Ф
    # port = @celltype.find( @next_cell_port_name )
    # signature = port.get_signature
    signature = @signature

    # through  signature ˴ޤޤ ٤ƤδؿˤĤ
    signature.get_function_head_array.each { |f|
      f_name = f.get_name
      f_type = f.get_declarator.get_type
      id = signature.get_id_from_func_name( f_name )

      # ؿ֤ͤĤ?
      if f_type.get_type.kind_of?( VoidType ) then
        b_void = true
      else
        b_void = false
      end

      # ѥåȤνå̤ΥǡĤäƤʤå
      file.print "    case #{id}:       /*** #{f_name} ***/ \n"
      file.print "        if( tTransparentUnmarshaler_#{@signature.get_name}_#{f_name}() != E_OK )\n"
      file.print "            goto error_reset;\n"
      file.print "        break;\n"

    } # 

    if @PPAllocatorSize then
      ppallocator_dealloc_str = "    /* PPAllocator Τ٤Ƥ */\n    cPPAllocator_dealloc_all();"
    else
      ppallocator_dealloc_str = ""
    end


    file.print <<EOT
    default:
        syslog(LOG_INFO, "unmarshaler task: ERROR: unknown func_id: %d", func_id_ );
    };
#{ppallocator_dealloc_str}
    return;

error_reset:
    if( ercd_ != ERCD( E_RPC, E_RESET ) )
        (void)cTDR_reset();
#{ppallocator_dealloc_str}
EOT

  end

  # IN b_marshal, b_get
  #  b_marshal = true  && b_get == false   :  ޡϰ
  #  b_marshal = true  && b_get == true    :  ޡǽϰ
  #  b_marshal = false && b_get == true    :  ޡϰ
  #  b_marshal = false && b_get == get     :  ޡǽϰ
  def print_params( params, file, nest, b_marshal, b_get, b_referenced, b_oneway = false )
    params.each{ |param|
# p "#{param.get_name}:  b_marshal: #{b_marshal} b_get: #{b_get}"
      if ! ( b_referenced == param.is_referenced? )
        next
      end

      dir = param.get_direction
      type = param.get_type
      if b_oneway && dir == :IN && type.get_original_type.kind_of?( PtrType ) || type.get_original_type.kind_of?( ArrayType ) then
        # oneway, in, PtrType ξ祳ԡ
        alloc_cp = "cPPAllocator_alloc"
        alloc_cp_extra = nil
        print_param( param.get_name, type, file, nest, dir, nil, nil, b_get, alloc_cp, alloc_cp_extra )
      else
        if( b_get == false && b_marshal == true || b_get == true && b_marshal == false  )then
          case dir
#          when :IN, :INOUT, :SEND
          when :IN, :INOUT, :OUT, :SEND, :RECEIVE
            print_param_nc( param.get_name, type, file, nest, b_marshal, nil, nil, b_get )
          end
        else
#         case dir
#         when :OUT, :INOUT, :RECEIVE
#         when :RECEIVE
#           print_param_nc( param.get_name, type, file, nest, b_marshal, nil, nil, b_get )
#         end
        end
      end
    }
  end

  def print_param_nc( name, type, file, nest, b_marshal, outer, outer2, b_get )
    indent = "    " * ( nest + 1 )

    case type
    when DefinedType
      print_param_nc( name, type.get_type, file, nest, b_marshal, outer, outer2, b_get )
    when BoolType, IntType, FloatType, PtrType, ArrayType
      case type
      when BoolType
        type_str = "Int8"
        cast_str = "int8_t"
      when IntType
        bit_size = type.get_bit_size
        case bit_size
        when -1
          type_str = "Char"
          cast_str = "char_t"
        when -2
          type_str = "Short"
          cast_str = "short_t"
        when -3
          type_str = "Int"
          cast_str = "int_t"
        when -4
          type_str = "Long"
          cast_str = "long_t"
        when -5
          type_str = "Intptr"
          cast_str = "intptr_t"
        when 8, 16, 32, 64, 128
          type_str = "Int#{bit_size}"
          cast_str = "int#{bit_size}_t"
        else
          raise "unknown bit_size '#{bit_size}' for int type "
        end

      when FloatType
        bit_size = type.get_bit_size
        if bit_size == 32 then
          type_str = "Float32"
          cast_str = "float32_t"
        else
          type_str = "Double64"
          cast_str = "double64_t"
        end

      when PtrType
        type_str = "Intptr"
        cast_str = "intptr_t"
      when ArrayType
        type_str = "Intptr"
        cast_str = "intptr_t"
      end

      if type.get_type_str == cast_str then
        cast_str = ""
      else
        cast_str = "(" + cast_str + ")"
      end

      if( b_get )then
        cast_str.gsub!( /\)$/, "*)" )
        file.print "    " * nest
        file.print "if( ( ercd_ = cTDR_get#{type_str}( #{cast_str}&(#{outer}#{name}#{outer2}) ) ) != E_OK )\n"
        file.print "    " * nest
        file.print "    goto error_reset;\n"
      else
        file.print "    " * nest
        file.print "if( ( ercd_ = cTDR_put#{type_str}( #{cast_str}#{outer}#{name}#{outer2} ) ) != E_OK )\n"
        file.print "    " * nest
        file.print "    goto error_reset;\n"
      end

    when StructType
      members_decl =type.get_members_decl
      members_decl.get_items.each { |m|
        if m.is_referenced?
          print_param_nc( m.get_name, m.get_type, file, nest, b_marshal, "#{outer}#{name}#{outer2}.", nil, b_get )
        end
      }
      members_decl.get_items.each { |m|
        if ! m.is_referenced?
          print_param_nc( m.get_name, m.get_type, file, nest, b_marshal, "#{outer}#{name}#{outer2}.", nil, b_get )
        end
      }

    when VoidType
    when EnumType  # mikan EnumType
    when FuncType  # mikan FuncType
    end
  end


  #=== PREAMBLE Υ
  # ޡ饻륿פξ硢ޡؿΥץȥ
  def gen_preamble file, b_singleton, ct_name, global_name
    if ct_name != @unmarshaler_celltype_name.to_sym then
      return
    end

    file.print "/* ޡؿΥץȥ */\n"
    # signature ˴ޤޤ ٤ƤδؿˤĤ
    @signature.get_function_head_array.each { |f|
      f_name = f.get_name
      f_type = f.get_declarator.get_type
      id = @signature.get_id_from_func_name( f_name )
      file.print "static ER  tTransparentUnmarshaler_#{@signature.get_name}_#{f_name}();\t/* func_id: #{id} */\n"
    }
    file.print "\n"
  end

  #=== POSTAMBLE Υ
  # ޡ饻륿פξ硢ޡؿ
  def gen_postamble file, b_singleton, ct_name, global_name
    if ct_name != @unmarshaler_celltype_name.to_sym then
      return
    end

    file.print "\n/*** ޡؿ ***/\n\n"
    @signature.get_function_head_array.each { |f|
      f_name = f.get_name
      f_type = f.get_declarator.get_type
      id = @signature.get_id_from_func_name( f_name )

      # ؿ֤ͤĤ?
      if f_type.get_type.kind_of?( VoidType ) then
        b_void = true
      else
        b_void = false
      end

      file.print <<EOT
/*
 * name:    #{f_name}
 * func_id: #{id} 
 */
EOT
      file.print "static ER\n"
      file.print "tTransparentUnmarshaler_#{@signature.get_name}_#{f_name}()\n"
      file.print "{\n"
      file.print "	ER  ercd_;\n"

      # ѿ
      param_list = f.get_declarator.get_type.get_paramlist.get_items
           # FuncHead->  Decl->    FuncType->ParamList
      param_list.each{ |par|
        name = par.get_name
        type = par.get_type
        if type.kind_of? ArrayType
          type = type.get_type
          aster = "(*"
          aster2 = ")"
        else
          aster = ""
          aster2 = ""
        end

        type_str = type.get_type_str.gsub( /\bconst\b */, "" ) # "const" 򳰤

        file.printf( "        %-12s%s%s%s%s;\n", type_str, aster, name, aster2, type.get_type_str_post )
      }

      # ͤѿ
      if ! b_void then
        if f.is_oneway? then
          retval_ptr = ""   # oneway ξ硢뤬ΤƤ
        else
          retval_ptr = "*"
        end
        file.printf( "        %-12s #{retval_ptr}retval_%s;\n", f_type.get_type.get_type_str, f_type.get_type.get_type_str_post )
      end

      # in Ϥ
      file.print "\n        /* ϰ */\n"
      b_get = true    # unmarshal Ǥ get
      b_marshal  = false
      print_params( param_list, file, 1, b_marshal, b_get, true, f.is_oneway? )
      print_params( param_list, file, 1, b_marshal, b_get, false, f.is_oneway? )
      if ! b_void && ! f.is_oneway? then
        ret_ptr_type = PtrType.new( f_type.get_type )
        print_param_nc( "retval_", ret_ptr_type, file, 2, :RETURN, nil, nil, b_get )
      end

      # ѥåȤμλ
      # mikan ϡоݴؿƽФ˼»ܤƽФѥåȤλѽŪȤ
      file.print "        /* ѥåȽå */\n"
      if ! f.is_oneway? then
        b_continue = "true"
      else
        b_continue = "false"
      end
      file.print "    if( (ercd_=cTDR_receiveEOP(#{b_continue})) != E_OK )\n"
      file.print "        goto error_reset;\n\n"

      # оݴؿƽФ
      file.print "    /* оݴؿθƽФ */\n"
      if b_void then
        file.print( "    cServerCall_#{f_name}(" )
      else
        file.print( "    #{retval_ptr}retval_ = cServerCall_#{f_name}(" )
      end

      delim = " "
      param_list.each{ |par|
        file.print delim
        delim = ", "
        file.print "#{par.get_name}"
      }
      file.print( " );\n" )

      # ͡ϰμ襳ɤ

      # oneway ξϡ̵ͤԤʤƱʸƽФ
      if ! f.is_oneway? then
        file.print <<EOT
    /* ؿνλ */
    if( ( ercd_ = cEventflag_set( 0x01 ) ) != E_OK ){
      goto error_reset;
    }
EOT
      end  # ! f.is_oneway?
      file.print <<EOT
    return E_OK;
error_reset:
    return ercd_;
}

EOT

    }

  end

end
